--- tar-1.23.orig/src/create.c
+++ tar-1.23/src/create.c
@@ -747,7 +747,7 @@
       return write_short_name (st);
     }
   else if (NAME_FIELD_SIZE - (archive_format == OLDGNU_FORMAT)
-	   < strlen (st->file_name))
+	   <= strlen (st->file_name))
     return write_long_name (st);
   else
     return write_short_name (st);
@@ -1399,7 +1399,7 @@
 	  block_ordinal = current_block_ordinal ();
 	  assign_string (&st->link_name, link_name);
 	  if (NAME_FIELD_SIZE - (archive_format == OLDGNU_FORMAT)
-	      < strlen (link_name))
+	      <= strlen (link_name))
 	    write_long_link (st);
 
 	  st->stat.st_size = 0;
